/*
	ZButton class	V0.1alpha
	
	This class will be part of the upcoming Zonic system.

	This class is copyright by Tinic Urou in 1996.
	
	If you want to use it write to: 5uro@informatik.uni-hamburg.de
*/
#include "bemain.h"

ZButton::
ZButton(
	BRect 		 frame,
	const char 	*name,
	const char 	*label,
	long 		pictype,
	BMessage 	*message,
	ulong resizeMask,
	ulong flags):
BControl(frame,name,label,message,resizeMask,flags)
{
	msg=message;
	pictyp=pictype;
}

void ZButton::DrawExtra(bool selected)
{
	struct font_info 	fi;
	BRect				temp;
	BPoint				foo;
	float				bar,add;
	if(Window()->Lock())
	{
	
		SetFontName("Emily");
		SetFontSize(10);
	
		if(!selected) 	SetHighColor(222,222,222);
		else			SetHighColor(188,188,188);
	
		FillRect(Bounds());
	
		if(!selected)	SetHighColor(255,255,255);
		else			SetHighColor(128,128,128);

		FillRect(BRect(BPoint(1,1),BPoint(1,Bounds().Height()-2)));
		FillRect(BRect(BPoint(1,1),BPoint(Bounds().Width()-2,1)));

		if(!selected)	SetHighColor(128,128,128,128);
		else			SetHighColor(255,255,255,255);
	
		FillRect(BRect(BPoint(2,Bounds().Height()-1),BPoint(Bounds().Width()-1,Bounds().Height()-1)));
		FillRect(BRect(BPoint(Bounds().Width()-1,2),BPoint(Bounds().Width()-1,Bounds().Height()-1)));
		GetFontInfo(&fi);
		SetHighColor(0,0,0,0);
		StrokeRect(Bounds());
		SetDrawingMode(B_OP_OVER);
	
		if(!IsEnabled()) SetHighColor(128,128,128);
	
		if(selected)add=1;else add=0;
	
		if(pictyp)
		{
			switch(pictyp)
			{
				case	PICTURE_PLAY:
						foo=BPoint(((Bounds().Width()-(Bounds().Height()-8))/2)+2+add,4+add);
						bar=Bounds().Height()-8;
						FillTriangle(foo,foo+BPoint(0,bar),foo+BPoint(bar,bar/2));
						break;					
				case	PICTURE_STOP:
						temp=BRect(BPoint(0,0),BPoint(Bounds().Height()-10,Bounds().Height()-10));
						temp.OffsetTo((Bounds().Width()-(Bounds().Height()-10))/2+add,5+add);
						FillRect(temp);
						break;
				case	PICTURE_NEXT:
						foo=BPoint(((Bounds().Width()-(Bounds().Height()-8))/2)-2+add,4+add);
						bar=Bounds().Height()-8;
						FillTriangle(foo,foo+BPoint(0,bar),foo+BPoint(bar,bar/2));
						FillRect(BRect(foo+BPoint(bar,0),foo+BPoint(bar+3,bar)));
						break;
				case	PICTURE_BACK:
						foo=BPoint(((Bounds().Width()-(Bounds().Height()-8))/2)-2+add,4+add);
						bar=Bounds().Height()-8;
						FillTriangle(foo+BPoint(bar+3,0),foo+BPoint(bar+3,bar),foo+BPoint(4,bar/2));
						FillRect(BRect(foo,foo+BPoint(3,bar)));
						break;
				case	PICTURE_PAUSE:
						temp=BRect(BPoint(0,0),BPoint((Bounds().Height()-10)/3,Bounds().Height()-10));
						temp.OffsetTo((Bounds().Width()-(Bounds().Height()-10))/2+add,5+add);
						FillRect(temp);
						temp.OffsetBy(BPoint( (((Bounds().Height()-10)/3)*2),0));
						FillRect(temp);
						break;
			}
		}
		else
		{
			MovePenTo(BPoint(((Bounds().Width()-StringWidth(Label()))/2)+add,(Bounds().Height()+fi.size)/2+add));
			DrawString(Label());	
		}
		Sync();
		Window()->Unlock();
	}
}

void ZButton::AttachedToWindow(void)
{
	norm=NULL;
	sele=NULL;
	
/*	NOT USED SINCE BEGINPICTURE()/ENDPICTURE() IS BUGGY IN DR7.1!

	norm = new BPicture();
	sele = new BPicture();

	BeginPicture(norm);
		DrawExtra(FALSE);
	EndPicture();
	
	BeginPicture(sele);
		DrawExtra(TRUE);
	EndPicture();
*/
}

ZButton::~ZButton()
{
	if(norm)delete norm;
	if(sele)delete sele;
}

void ZButton::SetPictureType(long type)
{
	pictyp=type;
	Draw(Bounds());
}

void ZButton::Draw(BRect updateRect)
{
	if(norm)DrawPicture(norm);
	else	DrawExtra(FALSE);
}

void ZButton::MouseDown(BPoint point)
{
	ulong 	buttons;
	bool	selected=TRUE,oldsel=FALSE;
	DrawExtra(TRUE);
	do 
	{
		snooze(30000);
		if
		(
			  (point.x>(Bounds().RightBottom().x))
			||(point.y>(Bounds().RightBottom().y))
			||(point.x<(Bounds().LeftTop().x))
			||(point.y<(Bounds().LeftTop().y))
		)
		{
			selected=FALSE;
			if(oldsel==TRUE)
			{
				if(norm)DrawPicture(norm);
				else	DrawExtra(FALSE);
				oldsel=FALSE;
			}
		}
		else
		{
			selected=TRUE;
			if(oldsel==FALSE)
			{
				if(sele)DrawPicture(sele);
				else	DrawExtra(TRUE);
				oldsel=TRUE;
			}
		}
		GetMouse(&point, &buttons);
	} 
	while ( buttons );
	
	if(norm)DrawPicture(norm);
	else	DrawExtra(FALSE);
	
	if(selected)
	{
		Window()->PostMessage(new BMessage(msg));
	}
}