// New NumberSlider class

bool	notick=FALSE;

class BNumberSlider : public BControl
{
	public:			BNumberSlider
					(
						BRect frame,
						const char *name,
						const char *label,
						const char *maxstr,
						void  (*SliderHook)(char *dest, long allowedsize, long value),
						BMessage *messsage,
						ulong resizeMask  = B_FOLLOW_LEFT | B_FOLLOW_TOP,
						ulong flags = B_WILL_DRAW
					); 
	virtual void	Draw(BRect updateRect);
	virtual void	MouseDown(BPoint where);
	virtual void 	DrawTheFuckinButton(BView *view, BRect frame);
	virtual void 	AttachedToWindow();
//	virtual void 	MakeDefault(bool state);
	
	virtual long	GetMinValue(void);
	virtual long	GetMaxValue(void);
	virtual BRect	GetButton(void);
	virtual	void	SetValue(long num);
	virtual	long	GetValue();		
	virtual	float 	GetMaxStrLngth();
	
	virtual void	SetMinValue(long val);
	virtual void	SetMaxValue(long val);
	
//			bool	IsDefault() const;

	private:	
			long 			Min;
			long			Max;
			long			Act;
	
			char			Str[255];
			float 			MaxStrLngth;
			const char		*MaxStr;
			long 			StrSiz;			
			BRect 			temp;
			void  			(*sliderhook)(char *dest, long allowedsize, long value);


			BMessage		*clickmsg;
};

class BNumberSliderWindow : public BWindow 
{
	public:	BNumberSliderWindow(BRect frame, BNumberSlider *slider);
};

class BNumberSliderView : public BView 
{
	public:	BNumberSliderView(BRect frame, BNumberSlider *slider);
	virtual void Draw(BRect update);
	private:
			BNumberSlider	*Slider;
};

BNumberSlider::
BNumberSlider
(
	BRect frame,
	const char *name,
	const char *label,
	const char *maxstr,
	void  (*SliderHook)(char *dest, long allowedsize, long value),
	BMessage *message,
	ulong resizeMask, 
	ulong flags
):
BControl(frame,name,label,message,resizeMask,flags)
{
	Min=0;
	Max=100;
	Act=66;
	StrSiz=255;
	MaxStr=maxstr;
	sliderhook=SliderHook;
	clickmsg=message;
}

void BNumberSlider::SetValue(long num)
{
	Act=num;
	Window()->Lock();
	Draw(Bounds());
	Window()->Unlock();
}
void	BNumberSlider::SetMaxValue(long val){Max=val;}
void	BNumberSlider::SetMinValue(long val){Min=val;}
long	BNumberSlider::GetValue(){return(Act);}
long	BNumberSlider::GetMinValue(){return(Min);}
long	BNumberSlider::GetMaxValue(){return(Max);}
BRect	BNumberSlider::GetButton(){return(temp);}
float	BNumberSlider::GetMaxStrLngth(){return(MaxStrLngth);}

void BNumberSlider::DrawTheFuckinButton(BView *view, BRect frame)
{
	struct font_info fi;
	BRect  work;
	float  inset;

	inset=frame.LeftTop().x;

	view->Window()->Lock();
	sliderhook(Str,255,Act);
	view->Window()->Unlock();
	
//	GetDrawString(Str,255,Act);
	
	view->SetHighColor(222,222,222);
	view->FillRect(frame);
	
	view->SetHighColor(255,255,255);

	view->StrokeLine(BPoint(1+inset,1),BPoint(1+inset,frame.Height()-2));
	view->StrokeLine(BPoint(1+inset,1),BPoint(frame.Width()-2+inset,1));

	view->SetHighColor(128,128,128);
	
	view->StrokeLine(BPoint(2+inset,frame.Height()-1),BPoint(frame.Width()-1+inset,frame.Height()-1));
	view->StrokeLine(BPoint(frame.Width()-1+inset,2),BPoint(frame.Width()-1+inset,frame.Height()-1));

	view->GetFontInfo(&fi);
	view->SetHighColor(0,0,0,0);
	view->StrokeRect(frame);
	view->SetDrawingMode(B_OP_OVER);
	view->MovePenTo(BPoint(((frame.Width()-view->StringWidth(Str))/2)+inset,(frame.Height()+fi.size)/2));
	view->DrawString(Str);	
	view->Sync();
}

void BNumberSlider::AttachedToWindow()
{
	Window()->Lock();
	SetFontName("Emily");
	SetFontSize(10);	
	MaxStrLngth=StringWidth(MaxStr)+4;	
	temp=BRect(Bounds().LeftTop(),BPoint(MaxStrLngth,Bounds().Height()));
	Window()->Unlock();
}

void BNumberSlider::Draw(BRect update)
{
	struct font_info fi;
	
	SetHighColor(ViewColor());
	if(temp.RightTop().x<update.RightBottom().x)
	{
		FillRect(BRect(temp.RightTop(),update.RightBottom()));
	}
	
	DrawTheFuckinButton(this,temp);
	
	GetFontInfo(&fi);
	
	MovePenTo(BPoint(MaxStrLngth+4,(Bounds().Height()+fi.size)/2));
	if(Label())DrawString(Label());
}

void BNumberSlider::MouseDown(BPoint point)
{
	BNumberSliderWindow	*win;
	BNumberSliderView *view;
	BPoint	topedge,lowedge,oldpoint=point;
	ulong 	buttons;
	long 	oldval=Act;
	BRect	work;
	
	notick=TRUE;
	
	oldpoint.x-=Act;
	
	topedge=Frame().LeftTop()+Window()->Frame().LeftTop();
	lowedge=topedge;
	lowedge.y+=Bounds().Height();
	lowedge.x+=MaxStrLngth+(abs(Min)+abs(Max));
	work=BRect(topedge,lowedge);
	work.OffsetBy((Min>0 ? Act+Min : (Min-Act)),0);
	
	win = new BNumberSliderWindow(work,this);
	win->AddChild(view = new BNumberSliderView(win->Bounds(),this));
	win->Show();
	do 
	{
		snooze(10000);
		Act=(point.x-oldpoint.x);
		if(Act>Max)Act=Max;
		if(Act<Min)Act=Min;
		if(Act!=oldval)
		{
			win->Lock();	
			view->Draw(view->Bounds());
			win->Unlock(),
			oldval=Act;
		}
		GetMouse(&point, &buttons);
	} 
	while ( buttons );
	Window()->Lock();
	Draw(Bounds());
	Window()->Unlock();
	win->PostMessage(B_QUIT_REQUESTED);
	if(clickmsg)Window()->PostMessage(new BMessage(clickmsg));
	
	notick=FALSE;
}

BNumberSliderWindow::BNumberSliderWindow(BRect frame, BNumberSlider *slider) : BWindow(frame, NULL, B_BORDERED_WINDOW, B_NOT_RESIZABLE | B_NOT_ZOOMABLE | B_WILL_ACCEPT_FIRST_CLICK)
{	
}

BNumberSliderView::BNumberSliderView(BRect frame, BNumberSlider *slider) : BView(frame, "", B_FOLLOW_NONE, B_WILL_DRAW)
{
	Slider=slider;	
}

void BNumberSliderView::Draw(BRect updateRect)
{
	long Min,Max,Act;
	BRect frame;
	Act=Slider->GetValue();
	Max=Slider->GetMaxValue();
	Min=Slider->GetMinValue();
	frame=Slider->GetButton();
	SetHighColor(222,222,222);
	frame.OffsetBy(Act,0);
	FillRect(BRect(BPoint(0,0),frame.LeftBottom()));
	FillRect(BRect(frame.RightTop(),Bounds().RightBottom()));
	SetFontName("Emily");
	SetFontSize(10);	
	Slider->DrawTheFuckinButton(this,frame);
}