/*

BeMikMod V1.3

:BEMAIN.CPP

Version history of this Be version:

	1.0		Inititial release. Quick and dirty
	
	1.1		I should know, that I must not call any Subscriber
	      	methods within a Subscriber hook. Cause dead
			Streams 8(( BMessages rulez! ;-)

			Changed startup and cleaned up source.
			
			Fixed headphone mode... channels were exchanged
			
			added gui
			
			removed argc handling.
	
	1.2		added resources support

	1.3		completly new gui (made two own classes)
	
			fixed problems with DupStr() returning 0s
			
			fixed tempo problem
			
			can now be louder... Hopefully works with all mods ...

			hmm... now its really usable... removed many
			small bugs...
			
	ToDo:
	
			- fixing the XM support... The author of MikMod told me
			  there could be Big-/Little-endian problems, he also
			  said they were the same problems with the Mac-Port... 
			  Lets see..
			- fixing of possible other bugs
			- finishing the program mode
			- Adding a preferences panel and saving the prefs to
			  the database.			
			- enhancing the about window... Needs a nice Logo...
*/
#include "bemain.h"

UNIMOD 		*mf=NULL;
MikMod 		*my_app; 
MikWindow	*aWindow;
MikView		*aView;
//	PListWindow *aLWindow;
//	PListView	*aLView;

#define MIK_QUIT	    'mkqt'
#define MIK_TICK		'mktq'
#define MIK_PLAY		'mkpl'
#define MIK_STOP		'mksp'
#define MIK_FORW		'mkfw'
#define MIK_BACK		'mkbk'
#define MIK_LOOP		'mklp'
#define MIK_HEAD		'mkhd'
#define MIK_PLST		'mkpi'
#define MIK_POSI		'mkpo'
#define MIK_VOLU		'mkvl'

ZButton	*g_play;
ZButton	*g_stop;
ZButton	*g_forw;
ZButton	*g_back;
ZButton	*g_plist;

// ZButton	*g_hide;
// ZButton	*g_delete;
// ZButton	*g_sort;
// ZButton	*g_save;
// ZButton *g_load;

BListView		*g_list;
BScrollView		*g_scro;
BScrollBar		*g_sbar;
BCheckBox 		*g_loop;
ZSlider 		*g_slider;
ZSlider			*g_pos;
ZSlider			*g_vol;

MikView::MikView(BRect rect):BView(rect,"MikMOD View", B_FOLLOW_ALL, B_WILL_DRAW)
{
}

void MikView::AttachedToWindow()
{
	SetFontName("Emily");
	SetFontSize(10);
	SetLowColor(200,200,200);
	SetViewColor(200,200,200);
}

void MikView::Draw(BRect updateRect)
{
	char str[256];
	SetHighColor(200,200,200);
	FillRect(updateRect);
	SetHighColor(0,0,0);
	SetFontName("Erich");
	SetFontSize(10);
	SetDrawingMode(B_OP_OVER);
	if(mf)
	{
		MovePenTo(BPoint(4, 10));
		DrawString("Songname");
		MovePenTo(BPoint(50, 10));
		sprintf(str,":\t%s",mf->songname ? mf->songname : "n.a.");
		DrawString(str);
		MovePenTo(BPoint(4, 20));
		DrawString("Modtype");
		MovePenTo(BPoint(50, 20));
		sprintf(str,":\t%s",mf->modtype ? mf->modtype : "n.a.");
		DrawString(str);
		MovePenTo(BPoint(4, 30));
		DrawString("Playmode");
		MovePenTo(BPoint(50, 30));
		sprintf(str,":\t%d chn, %d Hz",mf->numchn,md_mixfreq);
		DrawString(str);
	}
	SetFontName("Emily");
	SetFontSize(10);
}

bool MikView::MessageDropped(BMessage *msg,BPoint loc,BPoint offset)
{
	BMessage *msgnew;
	msgnew = new BMessage();
	
	msgnew->AddRef("refs",msg->FindRef("refs"));
	
	aWindow->PostMessage(msgnew);
	return(TRUE);
}

long oldtick=NULL;

void MikWindow::LoadMOD(BFile *file)
{
	char   *name;
	name=(char *)malloc(1024);
	file->GetPath(name,1024);
	
	if(mf)FreeMOD();	

	if(Lock())
	{
		aView->Draw(Bounds());
		aView->MovePenTo(BPoint(12,20));
		aView->DrawString("Loading file...");
		aView->Sync();
		Unlock();
	}

	if(mf=ML_LoadFN(name))
	{
		unsigned long type=NULL;
		
		g_pos->SetMinValue(0);
		g_pos->SetMaxValue(100);
		
		mp_sngpos=NULL;
		mp_patpos=NULL;
		
		oldtick=NULL;
		g_pos->SetValue(0);
		g_pos->SetMaxValue(mf->numpos-1);
		g_pos->SetMinValue(0);
		
		if(l)
		{
					if(strcmp(l->type,"S3M")==0) 					type ='S3M ';
			else	if(strcmp(l->type,"XM")==0) 					type ='XM  ';
			else	if(strcmp(l->type,"Standard module")==0) 		type ='MOD ';
			else	if(strcmp(l->type,"15-instrument module")==0) 	type ='MOD ';
			else	if(strcmp(l->type,"MTM")==0) 					type ='MOD ';
			else	if(strcmp(l->type,"STM")==0) 					type ='S3M ';
			else	if(strcmp(l->type,"ULT")==0) 					type ='MOD ';
		
			if(type)
			{
				unsigned long oldtype,oldcreator;
				file->GetTypeAndApp(&oldtype,&oldcreator);
				if(oldtype!=type)
				{
					file->SetTypeAndApp(type,'MODP');
				}
			}
		}
		
		MP_Init(mf);
		md_numchn=mf->numchn;
		MD_PlayStart();
		MD_Update();
		
		g_play->SetPictureType(PICTURE_PAUSE);
		
		if(Lock())
		{
			aView->Draw(aView->Bounds());
			Unlock();
		}
	}
	free(name);
}

bool sts_mod=TRUE;
bool forwards=FALSE;
bool backwards=FALSE;

void MikWindow::FreeMOD(void)
{
	MD_PlayStop(); 
	ML_Free(mf);  
	mf=NULL;
	sts_mod=TRUE;
}

MikWindow::MikWindow(BRect frame):BWindow(frame,"MikMod for BeOS 1.3",B_TITLED_WINDOW,B_NOT_ZOOMABLE|B_NOT_RESIZABLE)
{
}

void MikWindow::MessageReceived(BMessage *msg)
{
	record_ref 	theRef;
	BFile   	*theFile;
	int			t;
	extern		UWORD mp_channel,mp_sngspd;
	extern		int isfirst;
	extern		SWORD	posjmp;
	extern		UWORD	patbrk;
	extern		SBYTE	globalvolume;
	
	switch (msg->what) 
	{
		case 	MIK_STOP:
		case 	MIK_QUIT:
				if(aWindow->Lock())
				{
					if(mf)FreeMOD();
					aView->Draw(aView->Bounds());
					g_play->SetPictureType(PICTURE_PLAY);
					aWindow->Unlock();
			 	}
				return;
				
		case	MIK_POSI:
				t=g_pos->GetValue();
				if((t!=mp_sngpos)&&(mf))
				{
					isfirst=2; 
					posjmp=2;              
					patbrk=0;
					for(t=0;t<mf->numchn;t++)
					{
						mp_audio[t].kick=0;
						mp_audio[t].tmpvolume=0;
						mp_audio[t].retrig=0;
						mp_audio[t].wavecontrol=0;
						mp_audio[t].glissando=0;
						mp_audio[t].soffset=0;
					}
					mp_channel=0;
					mp_sngpos=g_pos->GetValue();
					if(!mp_sngpos)
					{
						mp_bpm=mf->inittempo;
						mp_sngspd=mf->initspeed;
						globalvolume=64;						
						auds->StartStreaming();	
					}
					mp_patpos=0;
				}
				return;
			
		case 	MIK_PLAY:
				if(mf)
				{
					if(sts_mod)
					{
						g_play->SetPictureType(PICTURE_PLAY);
						auds->StopStreaming();
						sts_mod=FALSE;
					}
					else
					{
						g_play->SetPictureType(PICTURE_PAUSE);
						auds->StartStreaming();
						sts_mod=TRUE;
					}
				}
				else my_app->RunFilePanel();
				return;
			
		case 	MIK_LOOP:
				if(g_loop->Value())
				{
					mp_loop=1;
				}
				else
				{
					mp_loop=0;
				}
				return;
				
/*		case	MIK_PLST:
				if(aLWindow->IsHidden())
				{
					aLWindow->Show();
				}
				else
				{
					aLWindow->Hide();
				}
				break;
*/
			
		case 	MIK_HEAD:
				md_head=g_slider->GetValue()>>1;
				return;
		
		case 	MIK_VOLU:
				mp_volume=g_vol->GetValue();
				return;
			
		case 	MIK_TICK:
				g_pos->SetValue(mp_sngpos);
				return;
/*	
		case	MIK_FORW:
				forwards=TRUE;
				return;
				
		case	MIK_BACK:
				backwards=TRUE;
				return;			
*/
	}
	
	theRef = msg->FindRef("refs");
    if (does_ref_conform(theRef,"File")) 
    {
		theFile = new BFile(theRef);
		LoadMOD(theFile);
		delete theFile;
		return;
    
	}	
}

bool MikWindow::QuitRequested()
{
	if(mf)FreeMOD();
	my_app->PostMessage(B_QUIT_REQUESTED);
	return TRUE;
}

void _SliderStringHook(char *dest, long allowedsize, long value)
{
	if(value==0)	
	{
		strcpy(dest,"STEREO");
	}
	else if(value<20)	
	{
		strcpy(dest,"stereo");
	}
	else if(value<80)	
	{
		sprintf(dest,"%ld%mix",value);
	}
	else if(value<100)	
	{
		strcpy(dest,"mono");
	}
	else if(value==100)	
	{
		strcpy(dest,"MONO");
	}
}

void _PosSliderStringHook(char *dest, long allowedsize, long value)
{
	if((!value)&&(mp_sngpos))
	{
		strcpy(dest,"Restart");
	}
	else 
	{
		sprintf(dest,"%03ld",value);
	}
}

void _VolSliderStringHook(char *dest, long allowedsize, long value)
{
	if(!value)
	{
		strcpy(dest,"mute");
	}
	else 
	if(value>200)
	{
		strcpy(dest,"LOUD");
	}
	else if(value>150)
	{
		strcpy(dest,"loud");
	}
	else 
	{
		sprintf(dest,"%ld%%bst",value);
	}
}

MikMod::MikMod():BApplication('MIKM')
{
	BRect	aRect;
	
	BPopUpMenu *menu = new BPopUpMenu("", FALSE, FALSE);
	BMenuItem *item;
	item = new BMenuItem("About MikMod...", new BMessage(B_ABOUT_REQUESTED), 'Q');
	menu->AddItem(item);
	item = new BMenuItem("Quit MikMod", new BMessage(B_QUIT_REQUESTED), 'Q');
	menu->AddItem(item);
	menu->SetTargetForItems(my_app);
	SetMainMenu(menu);
	
	aRect.Set(90, 37, 349, 90);
	aWindow = new MikWindow(aRect);
	
	aRect.OffsetTo(B_ORIGIN);
	aView = new MikView(aRect);
	
	aView->AddChild(g_play  = new ZButton(BRect(2,34,35,52),"Play","",PICTURE_PLAY,new BMessage(MIK_PLAY),B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW));
	aView->AddChild(g_stop  = new ZButton(BRect(37,34,70,52),"Eject","",PICTURE_STOP,new BMessage(MIK_STOP),B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW));
	aView->AddChild(g_back  = new ZButton(BRect(72,34,105,52),"Backward","",PICTURE_BACK,new BMessage(MIK_BACK),B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW));	
	aView->AddChild(g_forw  = new ZButton(BRect(107,34,140,52),"Forward","",PICTURE_NEXT,new BMessage(MIK_FORW),B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW));
	aView->AddChild(g_plist	= new ZButton(BRect(142,34,158,52),"Playlist","PL",NULL,new BMessage(MIK_PLST),B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW));
	aView->AddChild(g_loop  = new BCheckBox(BRect(212,19,295,33),"Loop Checkbox","Loop",new BMessage(MIK_LOOP),B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW));
	aView->AddChild(g_slider= new ZSlider(BRect(212,34,295,52),"Slider","","44%mix",_SliderStringHook,new BMessage(MIK_HEAD),B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW));
	aView->AddChild(g_pos   = new ZSlider(BRect(212,1,295,19),"PosSlider","","44%mix",_PosSliderStringHook,new BMessage(MIK_POSI),B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW));
	aView->AddChild(g_vol	= new ZSlider(BRect(160,34,210,52),"VolSlider","","144%mix",_VolSliderStringHook,new BMessage(MIK_VOLU),B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW));
	aWindow->AddChild(aView);
	
	if(aWindow->Lock())
	{
		g_back->SetEnabled(FALSE);
		g_forw->SetEnabled(FALSE);
		g_plist->SetEnabled(FALSE);
	
		g_loop->SetValue(TRUE);	
	
		g_pos->SetValue(0);
	
		g_slider->SetMaxValue(100);
		g_slider->SetMinValue(0);
		g_slider->SetValue(md_head<<1);
	
		g_vol->SetMaxValue(255);
		g_vol->SetMinValue(0);
		g_vol->SetValue(mp_volume);
	
		g_pos->SetViewColor(200,200,200);
		g_loop->SetViewColor(200,200,200);
		g_slider->SetViewColor(200,200,200);

		aWindow->Unlock();	
	}
/*	aRect.Set(316,37,516,260);
	aLWindow = new PListWindow(aRect);
	
	aRect.OffsetTo(B_ORIGIN);
	aLView = new PListView(aRect);

	aRect.Set(0,0,186,200);
	aLView->AddChild(g_list = new BListView(aRect,"Playlist",B_FOLLOW_ALL));
	aLView->AddChild(g_sbar = new BScrollBar(BRect(187,0,200,200),"ScrollBar",g_list,0,1000,B_VERTICAL));
	aLWindow->AddChild(aLView);
	g_list->SetTarget(aWindow, TRUE);
	
	aLView->AddChild(g_hide  = new ZButton(BRect(2,203,40,221),"Hide","Hide",NULL,new BMessage(MIK_PLAY),B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW));
	aLView->AddChild(g_save  = new ZButton(BRect(42,203,80,221),"Save","Save",NULL,new BMessage(MIK_PLAY),B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW));
	aLView->AddChild(g_load  = new ZButton(BRect(82,203,120,221),"Load","Load",NULL,new BMessage(MIK_PLAY),B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW));
	aLView->AddChild(g_delete= new ZButton(BRect(122,203,160,221),"Del","Del",NULL,new BMessage(MIK_PLAY),B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW));
	aLView->AddChild(g_sort  = new ZButton(BRect(162,203,198,221),"Sort","Sort",NULL,new BMessage(MIK_PLAY),B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW));
*/
	aWindow->Show();
}

void MikMod::ArgvReceived(int argc, char **argv)
{
	int    t,cmderr=0;
	BFile  *file;
	BMessage *msg;
	
	while( !cmderr && (t=getopt(argc,argv,"shxpm8irv:f:l:d:")) != EOF ); 
	file = new BFile();
	file->SetName(argv[optind]);
	msg = new BMessage();
	msg->AddRef("refs",file->Record()->Ref());
	if(aWindow) aWindow->PostMessage(msg);
	delete file;
}

void MikMod::RefsReceived(BMessage *message)
{
	// is this okay??? Or should I make a copy??
	aWindow->PostMessage(message);
}

void tickhandler(void)
{
	if(!MP_Ready())
	{
		if(forwards)
		{
			mp_sngpos++;
			mp_patpos=NULL;
			forwards=FALSE;
		}
		if(backwards)
		{
			if(mp_sngpos)mp_sngpos--;
			mp_patpos=NULL;
			backwards=FALSE;
		}
		MP_HandleTick();
		MD_SetBPM(mp_bpm);
		
	}
	if(mp_sngpos!=oldtick)
	{
		if(!notick)
		{
			aWindow->PostMessage(new BMessage(MP_Ready() ? MIK_QUIT : MIK_TICK));
		}
		else if(MP_Ready()) aWindow->PostMessage(new BMessage( MIK_QUIT ));
		oldtick=mp_sngpos;
	}
}


/*
PListWindow::PListWindow(BRect frame):BWindow(frame,"MikMos's PlayList",B_TITLED_WINDOW,B_NOT_ZOOMABLE|B_NOT_CLOSABLE|B_NOT_RESIZABLE)
{
}

PListView::PListView(BRect frame):BView(frame,"MikMOD PlayListView", B_FOLLOW_ALL, B_WILL_DRAW)
{
}

bool PListView::MessageDropped(BMessage *msg,BPoint loc,BPoint offset)
{
	BFile	*theFile;
	char	*name;
	
	if(does_ref_conform(msg->FindRef("refs"),"File"))
	{
		theFile = new BFile(msg->FindRef("refs"));
		
		name=(char *)malloc(33);
		theFile->GetName(name);
		g_list->AddItem(name);
		return(TRUE);	
	}
	return(FALSE);
}

void PListView::AttachedToWindow(void)
{
	SetViewColor(200,200,200);
	SetHighColor(200,200,200);	
}

void PListView::Draw(BRect updateRect)
{
	FillRect(updateRect);
}
*/


class AboutWindow : public BWindow 
{
	public:	AboutWindow();
};

class AboutView : public BView 
{
	public:	AboutView();
	virtual void AttachedToWindow(void);
	virtual void Draw(BRect update);
	virtual void MouseDown(BPoint point);
};

AboutWindow::AboutWindow() : BWindow(BRect(0,0,240,100), NULL, B_BORDERED_WINDOW, B_NOT_RESIZABLE | B_NOT_ZOOMABLE | B_WILL_ACCEPT_FIRST_CLICK)
{
	AboutView *view;
	
	if(Lock())
	{
		MoveTo(100,100);
		view = new AboutView;
		AddChild(view);
		view->MakeFocus();
		Unlock();
	}
	Show();
}

AboutView::AboutView() : BView(BRect(0,0,240,100), "", B_FOLLOW_NONE, B_WILL_DRAW) {}

void AboutView::AttachedToWindow(void)
{
	SetHighColor(0, 0, 0);
}

void AboutView::Draw(BRect update)
{
	SetHighColor(60, 60, 128);
	FillRect(BRect(0,0,360,200));
	SetHighColor(255, 255, 255);
	SetFontName("Emily");
	SetFontSize(12);
	SetDrawingMode(B_OP_OVER);
	MovePenTo(15, 20);
	DrawString("MikMod for BeOS V1.3");

	SetFontName("Erich");
	SetFontSize(9);
	MovePenTo(15, 40);
	DrawString("by Tinic Urou");
	MovePenTo(15, 52);
	DrawString("<5uro@informatik.uni-hamburg.de>");
	MovePenTo(15, 75);
	DrawString(" Copyright 1996");
	MovePenTo(15, 87);
	DrawString("Free distribution as long its not commercial.");
}

void AboutView::MouseDown(BPoint point)
{
	Window()->PostMessage(B_QUIT_REQUESTED);
}

void MikMod::AboutRequested(void)
{
	AboutWindow *win = new AboutWindow;
}

int md_head;

int main()
{                                   
	md_mixfreq      =44100;                   
	md_dmabufsize   =8192;                     
	md_mode         =DMODE_16BITS|DMODE_STEREO; 
	md_device       =0; 
	mp_loop			=1;
	md_head			=33;             
	mp_volume		=100;                                     

	ML_RegisterLoader(&load_m15);   
	ML_RegisterLoader(&load_mod);
	ML_RegisterLoader(&load_mtm);
	ML_RegisterLoader(&load_s3m);
	ML_RegisterLoader(&load_stm);
	ML_RegisterLoader(&load_ult);
	ML_RegisterLoader(&load_uni);
	ML_RegisterLoader(&load_xm);

//	MD_RegisterDriver(&drv_nos);		NULL driver
//	MD_RegisterDriver(&drv_raw);		Not really needed... Its a disksaver...
	MD_RegisterDriver(&drv_be);
	
	MD_RegisterPlayer(tickhandler);
	
	if(auds = new BAudioSubscriber("MikMOD Player"))
	{
		if(MD_Init())
		{
			my_app = new MikMod();
			my_app->Run();
			delete(my_app);
			MD_Exit();
		}
		delete auds;
	}
	return 0;
}
