#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <getopt.h>
#include "mikmod.h"
#ifndef _APPLICATION_H
#include <Application.h>
#include <AudioSubscriber.h>
#include <Control.h>
#include <Store.h>
#include <View.h>
#endif

class MikMod : public BApplication 
{
	public:			MikMod();	
	void 			RefsReceived(BMessage *message);	
	void			ArgvReceived(int argc, char **argv);
	void			AboutRequested(void);
};

class MikView : public BView 
{

	public:			MikView(BRect frame); 
	virtual	void	AttachedToWindow();
	virtual	void	Draw(BRect updateRect);
	virtual bool    MessageDropped(BMessage *msg,BPoint loc,BPoint offset);
};

class MikWindow : public BWindow 
{
	public:
					MikWindow(BRect frame); 
					void LoadMOD(BFile *file);
					void FreeMOD(void);
	virtual void	MessageReceived(BMessage *msg);
	virtual	bool	QuitRequested();
};

class PListWindow : public BWindow 
{
	public:
					PListWindow(BRect frame); 
//	virtual	bool	QuitRequested();
//	virtual void	MessageReceived(BMessage *msg);
};

/*
class PListView : public BView 
{
	public:			PListView(BRect frame); 
	virtual	void	AttachedToWindow();
	virtual	void	Draw(BRect updateRect);
	virtual bool	MessageDropped(BMessage *msg,BPoint loc,BPoint offset);
};

class PrefsWindow : public BWindow
{
	public:			PrefsWindow(void);
	virtual void	MessageReceived(BMessage *msg);
	virtual	bool	QuitRequested(void);
};
*/

extern UNIMOD 			*mf;
extern MikMod 			*my_app; 
extern MikWindow		*aWindow;
extern MikView			*aView;
extern BAudioSubscriber *auds;

extern LOADER *l;


#define PICTURE_PLAY	1
#define PICTURE_STOP	2
#define PICTURE_NEXT	3
#define PICTURE_BACK	4
#define PICTURE_PAUSE	5

class ZButton : public BControl
{
	public:			ZButton
					(
						BRect 		 frame,
						const char 	*name,
						const char 	*label,
						long		pictype,
						BMessage 	*message,
						ulong resizeMask  = B_FOLLOW_LEFT | B_FOLLOW_TOP,
						ulong flags = B_WILL_DRAW
					); 
	virtual			~ZButton();
	virtual void	Draw(BRect updateRect);
	virtual void 	DrawExtra(bool selected);
	virtual void	MouseDown(BPoint where);
	virtual	void 	AttachedToWindow(void);
			void	SetPictureType(long type);
	
	private:
			BMessage	*msg;
			long		pictyp;
			BPicture	*norm,*sele;
};

extern bool notick;

class ZSlider : public BControl
{
	public:			ZSlider
					(
						BRect frame,
						const char *name,
						const char *label,
						const char *maxstr,
						void  (*SliderHook)(char *dest, long allowedsize, long value),
						BMessage *messsage,
						ulong resizeMask  = B_FOLLOW_LEFT | B_FOLLOW_TOP,
						ulong flags = B_WILL_DRAW
					); 
	virtual void	Draw(BRect updateRect);
	virtual void	MouseDown(BPoint where);
	virtual void 	AttachedToWindow();
	
	virtual long	GetMinValue(void);
	virtual long	GetMaxValue(void);
	virtual BRect	GetButton(void);
	virtual	void	SetValue(long num);
	virtual	long	GetValue();		
	virtual	float 	GetMaxStrLngth();
	
	virtual void	SetMinValue(long val);
	virtual void	SetMaxValue(long val);
			void	DrawButton(BView *view, BRect frame);

	private:	

			void 	UpdateValue();

			long 			Min;
			long			Max;
			long			Act;
	
			char			Str[255];
			float 			MaxStrLngth;
			const char		*MaxStr;
			long 			StrSiz;			
			BRect 			temp;
			BRect			foo;
			void  			(*sliderhook)(char *dest, long allowedsize, long value);
			
			float			fontheight;
			
			BMessage		*clickmsg;
};

